diff --git a/src/main/java/net/minecraft/core/block/PaintedPlanksBlock.java b/src/main/java/net/minecraft/core/block/PaintedPlanksBlock.java
index a597b3867..f4ff81607 100644
--- a/src/main/java/net/minecraft/core/block/PaintedPlanksBlock.java
+++ b/src/main/java/net/minecraft/core/block/PaintedPlanksBlock.java
@@ -5,10 +5,11 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class PaintedPlanksBlock extends Block
+public class PaintedPlanksBlock extends Block implements IPainted
 {
     public PaintedPlanksBlock(String key, String namespaceId, int id)
     {
@@ -27,4 +28,28 @@ public class PaintedPlanksBlock extends Block
         return new ItemStack[] { new ItemStack(this, 1, meta) };
     }
 
+    @Override
+    public DyeColor fromMetadata(int meta) {
+        return DyeColor.colorFromBlockMeta(meta & 0x0F);
+    }
+
+    @Override
+    public int toMetadata(DyeColor color) {
+        return color.blockMeta;
+    }
+
+    @Override
+    public int stripColorFromMetadata(int meta) {
+        return 0;
+    }
+
+    @Override
+    public void removeDye(World world, int x, int y, int z) {
+        world.setBlockWithNotify(x, y, z, Blocks.PLANKS_OAK.id);
+    }
+
+    @Override
+    public void setColor(World world, int x, int y, int z, DyeColor color) {
+        IPainted.super.setColor(world, x, y, z, color);
+    }
 }
diff --git a/src/main/java/net/minecraft/core/block/PaintedSlabBlock.java b/src/main/java/net/minecraft/core/block/PaintedSlabBlock.java
index f96d247af..5afa1a745 100644
--- a/src/main/java/net/minecraft/core/block/PaintedSlabBlock.java
+++ b/src/main/java/net/minecraft/core/block/PaintedSlabBlock.java
@@ -4,10 +4,11 @@ import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class PaintedSlabBlock extends SlabBlock
+public class PaintedSlabBlock extends SlabBlock implements IPainted
 {
 	public PaintedSlabBlock(Block modelBlock, String namespaceId, int id)
 	{
@@ -24,4 +25,30 @@ public class PaintedSlabBlock extends SlabBlock
 		int meta = mob.getVerticalPlacementDirection(side, sideHeight) == Direction.UP ? 2 : 0;
 		world.setBlockMetadataWithNotify(x, y, z, meta | (world.getBlockMetadata(x, y, z) & 0xF0));
 	}
+
+	@Override
+	public DyeColor fromMetadata(int meta) {
+		return DyeColor.colorFromBlockMeta((meta & 0xF0) >> 4);
+	}
+
+	@Override
+	public int toMetadata(DyeColor color) {
+		return color.blockMeta << 4;
+	}
+
+	@Override
+	public int stripColorFromMetadata(int meta) {
+		return meta & 0xF;
+	}
+
+	@Override
+	public void removeDye(World world, int x, int y, int z) {
+		final int meta = world.getBlockMetadata(x, y, z);
+		world.setBlockAndMetadataWithNotify(x, y, z, Blocks.PLANKS_OAK.id, meta & 0xF);
+	}
+
+	@Override
+	public void setColor(World world, int x, int y, int z, DyeColor color) {
+		IPainted.super.setColor(world, x, y, z, color);
+	}
 }
diff --git a/src/main/java/net/minecraft/core/block/PaintedStairsBlock.java b/src/main/java/net/minecraft/core/block/PaintedStairsBlock.java
new file mode 100644
index 000000000..0b63bdb3d
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/PaintedStairsBlock.java
@@ -0,0 +1,36 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.world.World;
+
+public class PaintedStairsBlock extends StairsBlock implements IPainted {
+    public PaintedStairsBlock(Block block, String namespaceId, int id) {
+        super(block, namespaceId, id);
+    }
+
+    @Override
+    public DyeColor fromMetadata(int meta) {
+        return DyeColor.colorFromBlockMeta((meta & 0xF0) >> 4);
+    }
+
+    @Override
+    public int toMetadata(DyeColor color) {
+        return color.blockMeta << 4;
+    }
+
+    @Override
+    public int stripColorFromMetadata(int meta) {
+        return meta & 0xF;
+    }
+
+    @Override
+    public void removeDye(World world, int x, int y, int z) {
+        final int meta = world.getBlockMetadata(x, y, z);
+        world.setBlockAndMetadataWithNotify(x, y, z, Blocks.STAIRS_PLANKS_OAK.id, stripColorFromMetadata(meta));
+    }
+
+    @Override
+    public void setColor(World world, int x, int y, int z, DyeColor color) {
+        IPainted.super.setColor(world, x, y, z, color);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/PaintedTrapDoorBlock.java b/src/main/java/net/minecraft/core/block/PaintedTrapDoorBlock.java
index 8df5e8b66..16a34f478 100644
--- a/src/main/java/net/minecraft/core/block/PaintedTrapDoorBlock.java
+++ b/src/main/java/net/minecraft/core/block/PaintedTrapDoorBlock.java
@@ -5,10 +5,11 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class PaintedTrapDoorBlock extends TrapDoorBlock {
+public class PaintedTrapDoorBlock extends TrapDoorBlock implements IPainted {
     public PaintedTrapDoorBlock(String key, String namespaceId, int id, Material material) {
         super(key, namespaceId, id, material);
     }
@@ -23,4 +24,30 @@ public class PaintedTrapDoorBlock extends TrapDoorBlock {
     {
         return new ItemStack[] { new ItemStack(Blocks.TRAPDOOR_PLANKS_PAINTED, 1, (meta >> 4 & 0xF) << 4) };
     }
+
+    @Override
+    public DyeColor fromMetadata(int meta) {
+        return DyeColor.colorFromBlockMeta(meta >> 4 & 0xF);
+    }
+
+    @Override
+    public int toMetadata(DyeColor color) {
+        return color.blockMeta << 4;
+    }
+
+    @Override
+    public int stripColorFromMetadata(int meta) {
+        return meta & 0xF;
+    }
+
+    @Override
+    public void removeDye(World world, int x, int y, int z) {
+        final int meta = world.getBlockMetadata(x, y, z);
+        world.setBlockAndMetadataWithNotify(x, y, z, Blocks.TRAPDOOR_PLANKS_OAK.id, meta & 0xF);
+    }
+
+    @Override
+    public void setColor(World world, int x, int y, int z, DyeColor color) {
+        IPainted.super.setColor(world, x, y, z, color);
+    }
 }
diff --git a/src/main/java/net/minecraft/core/block/PlanksBlock.java b/src/main/java/net/minecraft/core/block/PlanksBlock.java
new file mode 100644
index 000000000..46d5f28ac
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/PlanksBlock.java
@@ -0,0 +1,17 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.world.World;
+
+public class PlanksBlock extends Block implements IPaintable {
+    public PlanksBlock(String translationKey, String namespaceId, int id, Material material) {
+        super(translationKey, namespaceId, id, material);
+    }
+
+    @Override
+    public void setColor(World world, int x, int y, int z, DyeColor color) {
+        world.setBlock(x, y, z, Blocks.PLANKS_OAK_PAINTED.id);
+        ((IPaintable) Blocks.PLANKS_OAK_PAINTED).setColor(world, x, y, z, color);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/PumiceBlock.java b/src/main/java/net/minecraft/core/block/PumiceBlock.java
new file mode 100644
index 000000000..e19cb0ada
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/PumiceBlock.java
@@ -0,0 +1,123 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.World;
+
+import java.util.Random;
+
+public class PumiceBlock extends Block {
+    final boolean isWet;
+    public PumiceBlock(String key, String namespaceId, int id, boolean isWet)
+    {
+        super(key, namespaceId, id, Material.stone);
+        this.isWet = isWet;
+    }
+
+    @Override
+    public void onBlockPlacedByWorld(World world, int x, int y, int z)
+    {
+        super.onBlockPlacedByWorld(world, x, y, z);
+        byte radius = 2;
+        if(isWet && (inWater(world, x, y, z) || world.dimension.id == Dimension.paradise.id)){
+            world.setBlockWithNotify(x, y, z, Blocks.PUMICE_DRY.id);
+            world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x + 0.5D, y + 0.5D, z + 0.5D, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
+            for(int l = 0; l < 8; l++)
+            {
+                world.spawnParticle("largesmoke", (double)x + Math.random(), (double)y + Math.random(), (double)z + Math.random(), 0.0D, 0.0D, 0.0D, 0);
+            }
+        }
+        if(!isWet && inLava(world, x, y, z)) {
+            for (int _x = x - radius; _x <= x + radius; _x++) {
+                for (int _y = y - radius; _y <= y + radius; _y++) {
+                    for (int _z = z - radius; _z <= z + radius; _z++) {
+                        if (Block.hasTag(world.getBlockId(_x, _y, _z), BlockTags.IS_LAVA)) {
+                            world.setBlockWithNotify(_x, _y, _z, 0);
+                        }
+                    }
+                }
+            }
+            world.setBlockWithNotify(x, y, z, Blocks.PUMICE_WET.id);
+        }
+    }
+
+
+    public boolean inLava(World world, int x, int y, int z){
+        if (Block.hasTag(world.getBlockId(x + 1, y, z), BlockTags.IS_LAVA))
+            return true;
+        if (Block.hasTag(world.getBlockId(x - 1, y, z), BlockTags.IS_LAVA))
+            return true;
+        if (Block.hasTag(world.getBlockId(x, y + 1, z), BlockTags.IS_LAVA))
+            return true;
+        if (Block.hasTag(world.getBlockId(x, y - 1, z), BlockTags.IS_LAVA))
+            return true;
+        if (Block.hasTag(world.getBlockId(x, y , z + 1), BlockTags.IS_LAVA))
+            return true;
+        if (Block.hasTag(world.getBlockId(x, y , z - 1), BlockTags.IS_LAVA))
+            return true;
+        return false;
+    }
+
+    public boolean inWater(World world, int x, int y, int z){
+        if (Block.hasTag(world.getBlockId(x + 1, y, z), BlockTags.IS_WATER))
+            return true;
+        if (Block.hasTag(world.getBlockId(x - 1, y, z), BlockTags.IS_WATER))
+            return true;
+        if (Block.hasTag(world.getBlockId(x, y + 1, z), BlockTags.IS_WATER))
+            return true;
+        if (Block.hasTag(world.getBlockId(x, y - 1, z), BlockTags.IS_WATER))
+            return true;
+        if (Block.hasTag(world.getBlockId(x, y , z + 1), BlockTags.IS_WATER))
+            return true;
+        if (Block.hasTag(world.getBlockId(x, y , z - 1), BlockTags.IS_WATER))
+            return true;
+        return false;
+    }
+
+    @Override
+    public void onBlockRemoved(World world, int x, int y, int z, int data)
+    {
+        if(!isWet) {
+            byte radius = 2;
+            for (int _x = x - radius; _x <= x + radius; _x++) {
+                for (int _y = y - radius; _y <= y + radius; _y++) {
+                    for (int _z = z - radius; _z <= z + radius; _z++) {
+                        world.notifyBlocksOfNeighborChange(_x, _y, _z, world.getBlockId(_x, _y, _z));
+                    }
+
+                }
+            }
+        }
+
+    }
+
+    @Override
+    public void animationTick(World world, int x, int y, int z, Random rand) {
+        if (isWet) {
+            Side side = Side.sides[rand.nextInt(6)]; // Get random side
+            if (side == Side.TOP || world.isBlockOpaqueCube(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ())) return;
+            float off1 = rand.nextFloat() * 0.9f + 0.05f;
+            float off2 = rand.nextFloat() * 0.9f + 0.05f;
+            switch (side) {
+                case BOTTOM:
+                    world.spawnParticle("dripLava", x + off1, y, z + off2, 0, 0, 0, 0);
+                    break;
+                case NORTH:
+                    world.spawnParticle("dripLava", x + off1, y + off2, z, 0, 0, 0, 0);
+                    break;
+                case SOUTH:
+                    world.spawnParticle("dripLava", x + off1, y + off2, z + 1, 0, 0, 0, 0);
+                    break;
+                case WEST:
+                    world.spawnParticle("dripLava", x, y + off1, z + off2, 0, 0, 0, 0);
+                    break;
+                case EAST:
+                    world.spawnParticle("dripLava", x + 1, y + off1, z + off2, 0, 0, 0, 0);
+                    break;
+            }
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/RedstoneBlock.java b/src/main/java/net/minecraft/core/block/RedstoneBlock.java
index 126ffeb1c..ccfc5ddda 100644
--- a/src/main/java/net/minecraft/core/block/RedstoneBlock.java
+++ b/src/main/java/net/minecraft/core/block/RedstoneBlock.java
@@ -31,7 +31,7 @@ public class RedstoneBlock extends Block
     @Override
     public boolean getDirectSignal(World world, int x, int y, int z, Side side)
     {
-        return false;
+        return getSignal(world, x, y, z, side);
     }
     
     @Override
diff --git a/src/main/java/net/minecraft/core/block/SpongeBlock.java b/src/main/java/net/minecraft/core/block/SpongeBlock.java
index 6507c428d..f583b79b5 100644
--- a/src/main/java/net/minecraft/core/block/SpongeBlock.java
+++ b/src/main/java/net/minecraft/core/block/SpongeBlock.java
@@ -6,13 +6,16 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 
+import java.util.Random;
+
 public class SpongeBlock extends Block
 {
-
+    final boolean isWet;
 	public SpongeBlock(String key, String namespaceId, int id, boolean isWet)
     {
         super(key, namespaceId, id, Material.sponge);
@@ -43,6 +46,7 @@ public class SpongeBlock extends Block
                     }
                 }
             }
+            world.setBlockWithNotify(x, y, z, Blocks.SPONGE_WET.id);
         }
     }
 
@@ -79,5 +83,32 @@ public class SpongeBlock extends Block
         }
 
     }
-    boolean isWet;
+
+    @Override
+    public void animationTick(World world, int x, int y, int z, Random rand) {
+        if (isWet) {
+            Side side = Side.sides[rand.nextInt(6)]; // Get random side
+            if (side == Side.TOP || world.isBlockOpaqueCube(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ())) return;
+            float off1 = rand.nextFloat() * 0.9f + 0.05f;
+            float off2 = rand.nextFloat() * 0.9f + 0.05f;
+            float lOff = 0.1f; // Dumb offset to fix bad lighting
+            switch (side) {
+                case BOTTOM:
+                    world.spawnParticle("dripWater", x + off1, y - lOff, z + off2, 0, 0, 0, 0);
+                    break;
+                case NORTH:
+                    world.spawnParticle("dripWater", x + off1, y + off2, z - lOff, 0, 0, 0, 0);
+                    break;
+                case SOUTH:
+                    world.spawnParticle("dripWater", x + off1, y + off2, z + 1 + lOff, 0, 0, 0, 0);
+                    break;
+                case WEST:
+                    world.spawnParticle("dripWater", x - lOff, y + off1, z + off2, 0, 0, 0, 0);
+                    break;
+                case EAST:
+                    world.spawnParticle("dripWater", x + 1 + lOff, y + off1, z + off2, 0, 0, 0, 0);
+                    break;
+            }
+        }
+    }
 }
diff --git a/src/main/java/net/minecraft/core/block/TrapDoorBlock.java b/src/main/java/net/minecraft/core/block/TrapDoorBlock.java
index be570f0d0..719283f39 100644
--- a/src/main/java/net/minecraft/core/block/TrapDoorBlock.java
+++ b/src/main/java/net/minecraft/core/block/TrapDoorBlock.java
@@ -8,6 +8,7 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.HitResult;
@@ -19,7 +20,7 @@ import net.minecraft.core.world.WorldSource;
 //            Block, Material, IBlockAccess, World, 
 //            AxisAlignedBB, Player, Vec3D, MovingObjectPosition
 
-public class TrapDoorBlock extends Block {
+public class TrapDoorBlock extends Block implements IPaintable {
     public TrapDoorBlock(String key, String namespaceId, int id, Material material) {
         super(key, namespaceId, id, material);
         float f = 0.5F;
@@ -214,4 +215,11 @@ public class TrapDoorBlock extends Block {
         if (metadata == 3) return Direction.WEST;
         return Direction.NONE;
     }
+
+    @Override
+    public void setColor(World world, int x, int y, int z, DyeColor color) {
+        final int meta = world.getBlockMetadata(x, y, z);
+        world.setBlockAndMetadata(x, y, z, Blocks.TRAPDOOR_PLANKS_PAINTED.id, meta);
+        ((IPaintable) Blocks.TRAPDOOR_PLANKS_PAINTED).setColor(world, x, y, z, color);
+    }
 }
diff --git a/src/main/java/net/minecraft/core/block/WoolBlock.java b/src/main/java/net/minecraft/core/block/WoolBlock.java
index 315025490..a97d0cb8b 100644
--- a/src/main/java/net/minecraft/core/block/WoolBlock.java
+++ b/src/main/java/net/minecraft/core/block/WoolBlock.java
@@ -5,10 +5,11 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class WoolBlock extends Block
+public class WoolBlock extends Block implements IPainted
 {
     public WoolBlock(String key, String namespaceId, int id) {
 
@@ -25,4 +26,24 @@ public class WoolBlock extends Block
     {
         return new ItemStack[] { new ItemStack(this, 1, meta) };
     }
+
+    @Override
+    public DyeColor fromMetadata(int meta) {
+        return DyeColor.colorFromBlockMeta(meta);
+    }
+
+    @Override
+    public int toMetadata(DyeColor color) {
+        return color.blockMeta;
+    }
+
+    @Override
+    public int stripColorFromMetadata(int meta) {
+        return 0;
+    }
+
+    @Override
+    public void removeDye(World world, int x, int y, int z) {
+        world.setBlockMetadataWithNotify(x, y, z, 0);
+    }
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/BlastFurnaceBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/BlastFurnaceBlockEntity.java
index 62473f635..5b6b34e58 100644
--- a/src/main/java/net/minecraft/core/block/entity/BlastFurnaceBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/BlastFurnaceBlockEntity.java
@@ -92,7 +92,7 @@ public class BlastFurnaceBlockEntity extends FurnaceBlockEntity
         {
         	if(worldObj == null || worldObj.getBlockId(x, y, z) == Blocks.FURNACE_BLAST_IDLE.id) {
             	if(currentBurnTime == 0 && furnaceItemStacks[0] == null) {
-            		if(furnaceItemStacks[1] != null && furnaceItemStacks[1].itemID == Blocks.NETHERRACK.id) {
+            		if(furnaceItemStacks[1] != null && furnaceItemStacks[1].itemID == Blocks.COBBLE_NETHERRACK.id) {
             			furnaceItemStacks[1].stackSize--;
             			if(furnaceItemStacks[1].stackSize <= 0) furnaceItemStacks[1] = null;
             			updateFurnace(true);
diff --git a/src/main/java/net/minecraft/core/block/entity/FurnaceBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/FurnaceBlockEntity.java
index 517a1590b..c88aeb46b 100644
--- a/src/main/java/net/minecraft/core/block/entity/FurnaceBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/FurnaceBlockEntity.java
@@ -183,7 +183,7 @@ public class FurnaceBlockEntity extends BlockEntity
         {
         	if(worldObj == null || worldObj.getBlockId(x, y, z) == Blocks.FURNACE_STONE_IDLE.id) {
             	if(currentBurnTime == 0 && furnaceItemStacks[0] == null) {
-            		if(furnaceItemStacks[1] != null && furnaceItemStacks[1].itemID == Blocks.NETHERRACK.id) {
+            		if(furnaceItemStacks[1] != null && furnaceItemStacks[1].itemID == Blocks.COBBLE_NETHERRACK.id) {
             			furnaceItemStacks[1].stackSize--;
             			if(furnaceItemStacks[1].stackSize <= 0) furnaceItemStacks[1] = null;
             			updateFurnace(true);
diff --git a/src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java
index f02f1a0da..ad118d63f 100644
--- a/src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java
@@ -180,7 +180,7 @@ public class TrommelBlockEntity extends BlockEntity
         {
         	if(worldObj == null || worldObj.getBlockId(x, y, z) == Blocks.TROMMEL_IDLE.id) {
             	if(currentItemBurnTime == 0 && itemStacks[0] == null) {
-            		if(itemStacks[4] != null && itemStacks[4].itemID == Blocks.NETHERRACK.id) {
+            		if(itemStacks[4] != null && itemStacks[4].itemID == Blocks.COBBLE_NETHERRACK.id) {
             			itemStacks[4].stackSize--;
             			if(itemStacks[4].stackSize <= 0) itemStacks[4] = null;
             			if (worldObj != null) {
diff --git a/src/main/java/net/minecraft/core/data/registry/Registries.java b/src/main/java/net/minecraft/core/data/registry/Registries.java
index 6f968f6ed..f73bf4200 100644
--- a/src/main/java/net/minecraft/core/data/registry/Registries.java
+++ b/src/main/java/net/minecraft/core/data/registry/Registries.java
@@ -64,8 +64,8 @@ public class Registries extends Registry<Registry<?>>
         RECIPE_TYPES.register("minecraft:smelting/blast", RecipeEntryBlastFurnace.class);
         RECIPE_TYPES.register("minecraft:trommeling", RecipeEntryTrommel.class);
 
-        ITEM_GROUPS.register("minecraft:stones",stackListOf(Blocks.STONE, Blocks.BASALT, Blocks.LIMESTONE, Blocks.GRANITE));
-        ITEM_GROUPS.register("minecraft:cobblestones",stackListOf(Blocks.COBBLE_STONE, Blocks.COBBLE_BASALT, Blocks.COBBLE_LIMESTONE, Blocks.COBBLE_GRANITE, Blocks.COBBLE_PERMAFROST));
+        ITEM_GROUPS.register("minecraft:stones",stackListOf(Blocks.STONE, Blocks.BASALT, Blocks.LIMESTONE, Blocks.GRANITE, Blocks.PERMAFROST, Blocks.NETHERRACK));
+        ITEM_GROUPS.register("minecraft:cobblestones",stackListOf(Blocks.COBBLE_STONE, Blocks.COBBLE_BASALT, Blocks.COBBLE_LIMESTONE, Blocks.COBBLE_GRANITE, Blocks.COBBLE_PERMAFROST, Blocks.COBBLE_NETHERRACK));
         ITEM_GROUPS.register("minecraft:planks",stackListOf(Blocks.PLANKS_OAK, new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 0), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 1), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 2), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 3), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 4), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 5), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 6), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 7), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 8), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 9), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 10), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 11), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 12), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 13), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 14), new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, 15)));
         ITEM_GROUPS.register("minecraft:grasses",stackListOf(Blocks.GRASS, Blocks.GRASS_RETRO));
         ITEM_GROUPS.register("minecraft:dirt",stackListOf(Blocks.DIRT, Blocks.DIRT_SCORCHED));
diff --git a/src/main/java/net/minecraft/core/item/Items.java b/src/main/java/net/minecraft/core/item/Items.java
index 7a9d62652..413bd6b27 100644
--- a/src/main/java/net/minecraft/core/item/Items.java
+++ b/src/main/java/net/minecraft/core/item/Items.java
@@ -188,6 +188,7 @@ public final class Items {
     public static Item FOOD_PUMPKIN_PIE;
     public static Item WAND_MONSTER_SPAWNER;
     public static Item DOOR_STEEL;
+    public static Item PAINTBRUSH;
     public static void init(){
         setupItems();
         initStats();
@@ -393,5 +394,6 @@ public final class Items {
         FOOD_PUMPKIN_PIE = (new PlaceableItem("food.pumpkin_pie", "minecraft:item/food_pumpkin_pie", 16535, Blocks.PUMPKIN_PIE)).setMaxStackSize(1);
         WAND_MONSTER_SPAWNER = (new SpawnerWandItem("wand.monster", "minecraft:item/wand_monster", 16536)).setMaxStackSize(1);
         DOOR_STEEL = (new DoorItem("door.steel", "minecraft:item/door_steel", 16537, Blocks.DOOR_STEEL_BOTTOM, Blocks.DOOR_STEEL_TOP));
+        PAINTBRUSH = new PaintBrushItem("paintbrush", "minecraft:item/paintbrush", 16538);
     }
 }
diff --git a/src/main/java/net/minecraft/core/item/PaintBrushItem.java b/src/main/java/net/minecraft/core/item/PaintBrushItem.java
new file mode 100644
index 000000000..13531e0f1
--- /dev/null
+++ b/src/main/java/net/minecraft/core/item/PaintBrushItem.java
@@ -0,0 +1,115 @@
+package net.minecraft.core.item;
+
+import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.IPaintable;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.player.inventory.slot.Slot;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+
+public class PaintBrushItem extends Item {
+    private static final int DAMAGE_PER_DYE = 8;
+
+    public PaintBrushItem(String translationKey, String namespaceId, int id) {
+        super(translationKey, namespaceId, id);
+        setMaxStackSize(1);
+        setMaxDamage(64);
+    }
+
+    @Override
+    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+        if (itemstack.getMetadata() >= itemstack.getMaxDamage()) {
+            return false;
+        }
+
+        final int id = world.getBlockId(blockX, blockY, blockZ);
+        final Block block = Block.getBlock(id);
+
+        if (block instanceof IPaintable) {
+            final IPaintable paintable = (IPaintable) block;
+            final DyeColor color = getColor(itemstack);
+            if (color != null) {
+                paintable.setColor(world, blockX, blockY, blockZ, color);
+                itemstack.damageItem(1, entityplayer);
+                return true;
+            }
+        }
+
+        return false;
+    }
+
+    @Override
+    public boolean hasInventoryInteraction() {
+        return true;
+    }
+
+    @Override
+    public ItemStack onInventoryInteract(Player player, Slot slot, ItemStack stackInSlot, boolean isItemGrabbed) {
+        if (isItemGrabbed) {
+            return stackInSlot;
+        }
+
+        final DyeColor currentColor = getColor(stackInSlot);
+        final int dyeCount = getDyeCount(stackInSlot);
+
+        final ItemStack grabbedItem = player.inventory.getHeldItemStack();
+
+        if (grabbedItem != null && grabbedItem.getItem() instanceof DyeItem) {
+            final DyeColor newColor = DyeColor.colorFromItemMeta(grabbedItem.getMetadata());
+            if (currentColor != newColor) {
+                setColor(stackInSlot, newColor);
+                setDyeCount(stackInSlot, DAMAGE_PER_DYE);
+                grabbedItem.stackSize--;
+                if (grabbedItem.stackSize <= 0) {
+                    player.inventory.setHeldItemStack(null);
+                }
+            } else {
+                final int newDyeCount = Math.min(dyeCount + DAMAGE_PER_DYE, stackInSlot.getMaxDamage());
+                setDyeCount(stackInSlot, newDyeCount);
+                grabbedItem.stackSize--;
+                if (grabbedItem.stackSize <= 0) {
+                    player.inventory.setHeldItemStack(null);
+                }
+            }
+        }
+
+        return stackInSlot;
+    }
+
+    @Override
+    public boolean showFullDurability() {
+        return true;
+    }
+
+    public int getDyeCount(ItemStack stack) {
+        return stack.getMaxDamage() - stack.getMetadata();
+    }
+
+    public void setDyeCount(ItemStack stack, int count) {
+        stack.setMetadata(stack.getMaxDamage() - count);
+    }
+
+    public DyeColor getColor(ItemStack stack) {
+        CompoundTag tag = stack.getData();
+        if (tag.containsKey("Color")) {
+            final int color = tag.getInteger("Color");
+            if (color < 0) {
+                return null;
+            }
+            return DyeColor.colorFromItemMeta(color & 0x0F);
+        } else {
+            return null;
+        }
+    }
+
+    public void setColor(ItemStack stack, DyeColor color) {
+        CompoundTag tag = stack.getData();
+        if (color == null) {
+            tag.putInt("Color", -1);
+        } else {
+            tag.putInt("Color", color.itemMeta);
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
index b0c260f8f..992d35d66 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
@@ -83,6 +83,13 @@ public class ChunkDecoratorNether
             (new WorldFeatureLake(Blocks.FLUID_LAVA_STILL.id)).place(world, rand, xf, yf, zf);
         }
 
+        for (int i = 0; i < /*20*/80; i++) {
+            int xf = x + rand.nextInt(16);
+            int yf = minY + rand.nextInt(rangeY);
+            int zf = z + rand.nextInt(16);
+            (new WorldFeaturePumice(32)).place(world, rand, xf, yf, zf);
+        }
+
         SandBlock.fallInstantly = false;
 
     }
diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
index 5a9b74363..1d4d3f013 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.world.generate.chunk.perlin.nether;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
@@ -93,7 +92,7 @@ public class SurfaceGeneratorNether
                             }
                             if(generateGravelBeach)
                             {
-                                fillerBlock = (short) Blocks.NETHERRACK.id;
+                                fillerBlock = (short) Blocks.COBBLE_NETHERRACK.id;
                             }
                             if(generateSandBeach)
                             {
